<%@ page language="java" import="com.ibm.ut.commenter.service.*,java.util.*, com.ibm.ut.help.common.web.*, com.ibm.ut.help.common.*, com.ibm.ut.help.common.security.*, com.ibm.ut.commenter.*, javax.servlet.http.*, org.eclipse.core.runtime.Preferences;" contentType="text/html;UTF-8" pageEncoding="UTF-8"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%
	Locale locale = LocaleUtil.getLocale(request);
	boolean showBanner = request.getParameter("banner")==null || request.getParameter("banner").equals("true");
	
	HTMLUtil.handleAuth(request,response,new Properties(),AuthenticationService.getAuthenticator());

%>
<html>
    <head>
    	<title>Comment Viewer</title>
        <link rel="stylesheet" type="text/css" href="../dojotoolkit/dijit/themes/tundra/tundra.css" />
        <link rel="STYLESHEET" type="text/css" href="../topic/com.ibm.ut.help.common/css/utcommon.css" />
<% 	if (showBanner){ 	%>
        <link rel="STYLESHEET" type="text/css" href="../topic/com.ibm.ut.help.common/banner/banner.css" />
<%	}	%>          
		<script type="text/javascript" src="../dojotoolkit/dojo/dojo.js.uncompressed.js" djConfig="isDebug:true,parseOnLoad:true"></script>
        <script type="text/javascript" src="../topic/com.ibm.ut.help.common/scripts/utcommon.js"></script>     
 
        <style type="text/css">
        
            @import "../dojotoolkit/dojo/resources/dojo.css";
            @import "../dojotoolkitext/ibm/themes/jazz/jazz.css";
            @import "css/customStyles.css";
			
        </style>
        <script type="text/javascript">

            dojo.require("dijit.TitlePane");
			dojo.require("dojo.data.ItemFileWriteStore");
			dojo.require("dijit.tree.ForestStoreModel");
			dojo.require("dijit.layout.ContentPane");
			dojo.require("dojox.grid.DataGrid");
            dojo.require("dijit.Editor");
            dojo.require("dijit.Tooltip");
            dojo.require("dijit.Dialog");
            dojo.require("dijit.form.Select");
			dojo.require("dijit.form.ToggleButton");
            dojo.require("dijit.form.ValidationTextBox");
			
			dojo.registerModulePath("ibm", "../../dojotoolkitext/ibm");
			dojo.require("ibm.data.RESTItemStore");

            dojo.addOnLoad(function(){

//				dojo.connect(commentsGridStore, "onNew", bypassChanged);
//				dojo.connect(commentsGridStore, "onSet", bypassChanged);
//				dojo.connect(commentsGridStore, "onDelete", bypassChanged);
	
		        dojo.connect(commentsGrid, "onCellMouseOver", showTooltip);
		        dojo.connect(commentsGrid, "onCellMouseOut", hideTooltip);
	        });
            
	 		function showTooltip(e) {
	            if (e.cell.id.indexOf("3")==-1) {
					return;
	            } 

                var item = e.grid.getItem(e.rowIndex);
				var id = e.grid.store.getValue(item, e.cell.field);
				var frame = '<iframe src="../topic'+id.substring(0,id.lastIndexOf("/"))+'" name="'+id+'_Frame" style="overflow:visible; width:600px;height:400px;" frameborder="0">x</iframe>';
                dijit.showTooltip(frame, e.cellNode);
	        }
	        
	        function hideTooltip(e) {
	            dijit.hideTooltip(e.cellNode);
	        }
              
            
            
			function htmlFormatter(val)
			{
				val=val.replace(/&lt;/g,"<"); 
				val=val.replace(/&gt;/g,">"); 
				return val;			
			}
			
			// Action Button formatter
			function buttonFormatter(name)
			{
				return '<a title="<%=MessageLibrary.getString("Edit", locale)%>" href="javascript:gridEdit(\''+name+'\')" class="gridEdit" style="width:25px;height:25px;">&nbsp;&nbsp;&nbsp;&nbsp;</a><a title="<%=MessageLibrary.getString("Remove", locale)%>" href="javascript:gridRemove(\''+name+'\')" class="gridRemove" style="width:25px;height:25px;">&nbsp;&nbsp;&nbsp;&nbsp;</a>';			
			}
			
			function topicFormatter(id)
			{
				return '<a id="'+id+'" href="../topic'+id.substring(0,id.lastIndexOf("/"))+'">'+id+'</a>';
			}
			
			function gridEdit(id)
			{
				commentsGridStore.fetch({
					query: {id:id},
					onItem:function(item){
				   		dijit.byId('commentEditor').setValue(item.description[0]);
						document.getElementById("nameField").value = item.name[0];
						document.getElementById("emailField").value = item.email[0];
						document.getElementById("stateField").value = item.state[0];
						dijit.byId('commentDialogOK').name = id;
				 	}
				});				
				dijit.byId('commentDialog').show();
			}
			
			function gridEdited(button)
			{
				var id = button.name;
				commentsGridStore.fetch({
					query: {id:id},
					onItem:function(item){
						commentsGridStore.setValue(item,"description",dijit.byId('commentEditor').getValue());
						commentsGridStore.setValue(item,"name",document.getElementById("nameField").value);
						commentsGridStore.setValue(item,"email",document.getElementById("emailField").value);
						commentsGridStore.setValue(item,"state",dijit.byId("stateField").value);
						saveGrid();
				 	}
				});			
				dijit.byId('commentDialog').hide();	
			}
			
			function gridRemove(id)
			{
				dijit.byId('deleteDialogOK').name = id;
				dijit.byId('deleteDialog').show();
			}
			
			function gridRemoved(button)
			{
				var id = button.name;
				commentsGridStore.fetch({
					query: {id:id},
					onItem:function(item){
						commentsGridStore.deleteItem(item);
						saveGrid();
				 	}
				});
				dijit.byId('deleteDialog').hide();	
			}
			
			function saveGrid()
			{
				commentsGridStore.save({onComplete:function(){
					commentsGridStore.close();
					commentsGridStore.fetch();
					commentsGrid.setStore(commentsGridStore, { id: '*' });          
	            }});
			}
			
        </script>
    </head>

    <body class="jazz">    	
        <span dojoType="ibm.data.RESTItemStore" 
    		jsId="commentsGridStore"
    		useIdentifier="true"
    		saveURL="../com.ibm.ut.commenter.service.CommentService"
    		url="../com.ibm.ut.commenter.service.CommentService">
    	</span>
    	
<%	if (showBanner){	%>
		<!-- BEGIN IBM BANNER -->
		<div class="bannerContainer">
			<div class="headerContainer">
				<div class="headerCenter">
					<div class="headerLeft"></div>
					<div class="headerRight"></div>
				</div>
			</div>
			<div class="bannerContent">
				<div class="helpLogo"></div>
				<div class="helpTitle">Rational Help Comment Viewer</div>
				<div class="ibmLogo"></div>
			</div>
		</div>
	    <!-- END IBM BANNER -->

		<table class="banneredTable jazz_clear" cellspacing="15">
<%	}else{	%>	
		<table class="mainTable jazz_clear" cellspacing="15">
<%	}	%>	
			<tr>
				<td>
					<table id="commentsGrid"
						jsId="commentsGrid"
						dojoType="dojox.grid.DataGrid"
						query="{ id: '*' }"
						store="commentsGridStore"
						clientSort="true"
						rowSelector="16px"
						selectionMode="none"
						autoheight="true"
						escapeHTMLInData="false">
						<thead>
							<tr>
								<th width="4%" field="name">
									Name
								</th>
								<th width="4%" field="email">
									E-mail
								</th>
								<th width="12%" field="time">
									Date
								</th>
								<th width="17%" field="id" formatter="topicFormatter">
									Plugin / Topic
								</th>
								<th width="55%" field="description">
									Comment
								</th>
								<th width="4%" field="state">
									State
								</th>
								<th width="4%" field="id" formatter="buttonFormatter">
									Actions
								</th>
							</tr>
						</thead>
					</table>				
				</td>
			</tr>
		</table>  
		
		<div dojoType="dijit.Dialog" id="commentDialog" title="Comment">
			<table>
				<tr>
					<td>Name:</td>
					<td><input name="nameField" required="true" dojotype="dijit.form.ValidationTextBox" id="nameField" style="width:470px;"/></td>
				</tr>
				<tr>
					<td>Email:</td>
					<td><input name="emailField" dojotype="dijit.form.ValidationTextBox" id="emailField" style="width:470px;"/></td>
				</tr>
				<tr>
					<td>State:</td>
					<td>
						<select dojoType="dijit.form.Select" jsId="stateField" id="stateField" name="stateField" style="width:125px;">
						    <option value="Open">
						        Open
						    </option>
						    <option value="Closed">
						        Closed
						    </option>
						    <option value="Deleted">
						        Deleted
						    </option>
						</select>
					</td>
				</tr>
				<tr>
					<td>Description:</td>
					<td><div dojoType="dijit.Editor" id="commentEditor"></div></td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td>
						<button id="commentDialogOK" dojoType="dijit.form.Button" type="submit" 
							onclick="gridEdited(this)" disabled="false"><%=MessageLibrary.getString("OK",locale)%></button>
						<button id="commentDialogCancel" dojoType="dijit.form.Button" type="submit" onclick="javascript:dijit.byId('commentDialog').hide()"><%=MessageLibrary.getString("Cancel",locale)%></button>
					</td>
				</tr>	
			</table>
		</div>  
		
		<div dojoType="dijit.Dialog" id="deleteDialog" title="Delete">
			<table>
				<tr>
					<td>Do you really want to delete this comment?</td>
				</tr>
				<tr>
					<td>
						<button id="deleteDialogOK" dojoType="dijit.form.Button" type="submit" 
							onclick="gridRemoved(this)" disabled="false"><%=MessageLibrary.getString("OK",locale)%></button>
						<button id="deleteDialogCancel" dojoType="dijit.form.Button" type="submit" onclick="javascript:dijit.byId('deleteDialog').hide()"><%=MessageLibrary.getString("Cancel",locale)%></button>
					</td>
				</tr>	
			</table>
		</div>  
				
	</body>
</html>
       